import sys,os,time,msvcrt 
from ctypes import * 

partner_connected = 0
lcb = 0                # login callback flag
ch = c_void_p(0) # connection handle
oh = c_void_p(0) # operational handle
nh = c_void_p(0) # node handle
dh = c_void_p(0) # device handle
NULL = c_void_p(0)
LOGIN_SERVICE = c_ulong(16464)

def notify_cb():
     global partner_connected
     print "Notify callback called"
     partner_connected = 1
     return 0

def login_cb(nh, username, password, box, box1, box2):
 global lcb
 lcb = 1
 print "login callback called"
 print "Username:",username
 print "password:",password
 #print hex(box)  # Integer box
 return 0

uchr = lambda x: chr((256+x) % 256)  # signed->unsigned ints

# ----------- get a path to navnet.dll ------
# Win32: C:\Program Files\Common Files\TI Shared\CommLib\1\NavNet 
# Win64: C:\Program Files (x86)\Common Files\TI Shared\CommLib\1\NavNet
if os.environ.get("CommonProgramFiles(x86)"):      # Win64
 pt = os.environ.get("CommonProgramFiles(x86)") 
 nndll = pt + '\TI Shared\CommLib\\1\NavNet' + "\\navnet.dll"
else:                              # Win32
 pt = os.environ.get("CommonProgramFiles") 
 nndll = pt +'\TI Shared\CommLib\\1\NavNet' + "\\navnet.dll"

############# load NavNet.dll 
nn = cdll.LoadLibrary(nndll)    

#------------ init navnet
status = nn.TI_NN_Init("-c 0 -d 0 ")
print "TI_NN_Init:%d" %(status)

#------------- setup the callback for TI_NN_RegisterNotifyCallback
CBFUNC = CFUNCTYPE(c_int)
#cb_func = CBFUNC(service_cb)
cb_func2 = CBFUNC(notify_cb)

status = nn.TI_NN_RegisterNotifyCallback(0, cb_func2)
while partner_connected == 0:
 time.sleep(1)
print "TI_NN_RegisterNotifyCallback %d:" % (status)

#--------- login test
oh = nn.TI_NN_CreateOperationHandle()
nn.TI_NN_NodeEnumInit(oh)
nn.TI_NN_NodeEnumNext(oh,byref(nh))
nn.TI_NN_NodeEnumDone(oh)
status = nn.TI_NN_Connect(nh,16464,byref(ch))  # connect to login service
LOGIN_CB = CFUNCTYPE(c_int,c_void_p,c_char_p,c_char_p,c_void_p,c_void_p,c_void_p)
loginListener = LOGIN_CB(login_cb)
nn.TI_NN_LoginServiceStart(loginListener)
print "TI_NN_LoginServiceStart:%d" %(status)
print "Waiting for login"
while lcb == 0:
 time.sleep(.125)
nn.TI_NN_LoginServiceStop()
# result = NavNet.login(nh, opHandle, "username", "password", new IntegerBox(4), new IntegerBox(6));

  
nn.TI_NN_DestroyOperationHandle(oh)
nn.TI_NN_Disconnect(ch)
nn.TI_NN_Shutdown()
